<template>
  <div id="teacher_class_new_wrapper" class="bt-container">
     <div class="page-title">
      <template v-if="isEdit">
        {{ $t('TEACHER_CLASS.EDIT_COURSE') }}
      </template><template v-else>
        {{ $t('TEACHER_CLASS.REGISTER_COURSE') }}
      </template>
    </div>
    <el-row :gutter="20">
      <el-col :span="12">
        <el-form :model="mainForm" ref="elForm" label-position="left" label-width="125px" style="max-width: 800px;" class="elForm-label">
          <el-form-item :label="$t('TEACHER_CLASS.CRS_NAME')">
            <el-input v-model="mainForm.name" class="subject-title"></el-input>
            <font color="red" size="5em">*</font>
          </el-form-item>

          <el-form-item :label="$t('TEACHER_CLASS.DETAIL_INTRO_INSTR')">
            <el-input type="textarea" :rows="6" v-model="mainForm.description" class="subject-description"></el-input>
          </el-form-item>

          <el-form-item :label="$t('TEACHER_CLASS.OPEN_CRS')">
            <el-switch v-model="mainForm.opened"></el-switch>
          </el-form-item>

          <el-form-item :label="$t('TEACHER_CLASS.PRACT_USE')">
            <el-switch v-model="mainForm.practice"></el-switch>
            <el-popover
              style="position: relative; left: 10px; top: 3px;"
              placement="top-start"
              width="400"
              trigger="hover">
                {{ $t('TEACHER_CLASS.PYTHON_USE') }}
              <i class="el-icon-question fa-lg" slot="reference"></i>
            </el-popover>
          </el-form-item>

          <el-form-item :label="$t('STUDENT_MENU.CHS_INSTRCT')">
            <div v-for="(value, index) in mainForm.teacher_user_id" :key="index">
              <el-select id="teacher-choice" v-model="mainForm.teacher_user_id[index]" style="width:350px;">  
                <el-option 
                  v-for="element in teacherList"
                  :key="element.email_id"
                  :label="element.nameAndmail"
                  :value="element.user_id">
                </el-option>
              </el-select>
              <el-button v-if="index === 0" size="small" type="primary" icon="el-icon-plus" @click="addTeacherSlot"></el-button>
              <el-popover
                v-if="index === 0"
                style="position: relative; left: 10px; top: 3px;"
                placement="top-start"
                width="400"
                trigger="hover">
                  {{ $t('TEACHER_CLASS.REPRESENT_LECER') }}
                <i class="el-icon-question fa-lg" slot="reference"></i>
              </el-popover>
              <el-button v-if="index !== 0" size="small" type="danger" icon="el-icon-minus" @click="deleteTeacherSlot(index)"></el-button>
            </div>
          </el-form-item>

          <el-form-item :label="$t('TEACHER_CLASS.LIST_STUD')">
            <el-table
              :data="mainForm.studentList">
              <el-table-column
                prop="name"
                :label="$t('REG.NAME_LABEL')"
                width="120">
              </el-table-column>
              <el-table-column
                prop="email_id"
                :label="$t('TEACHER_CLASS.MAIL_ADDRESS')">
              </el-table-column>
              <el-table-column
                label="-"
                width="100"
                align="center"
              >
                <template slot-scope="scope">
                  <el-button size="small" type="danger" @click="removeStudent(scope.row.user_id)">X</el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-form-item>

          <el-button
            style="width: 100%"
            type="primary"
            @click="onSubmit"
            class="subject-btn"
          >
            <template v-if="isEdit">
              {{ $t('TEACHER_CLASS.EDIT_COURSE') }}
            </template><template v-else>
              {{ $t('TEACHER_CLASS.REGISTER_COURSE') }}
            </template>
          </el-button>
        </el-form>
      </el-col>

      <el-col :span="12">
        <div class="all-student-list">
          {{ $t('TEACHER_CLASS.LIST_STUDENT') }}
        </div>
        <el-form label-position="left" label-width="125px" class="bg-gray" style="padding: 15px 7px 10px 7px">
          <el-row>
            <el-col :span="6">
              <el-select
                v-model="searchForm.searchCategory"
                :placeholder="$t('TEACHER_CLASS.SELECT')"
                @change="onSearchCategoryChange">
                <el-option 
                  v-for="element in searchCategoryList"
                  :key="element.value"
                  :label="element.label"
                  :value="element.value">
                </el-option>
              </el-select>
            </el-col>
            <el-col :span="14">
              <div v-if="searchForm.searchCategory !== 'universityAndDepartment'">
                <el-input v-model="searchForm.searchValue">
                </el-input>
              </div>
              <div v-if="searchForm.searchCategory === 'universityAndDepartment'">
                <el-select id="teacher-choice" v-model="searchForm.searchValue[0]" :disabled="input.isActive" style="width:49%;">  
                  <el-option
                    v-for="element in input.teacherList"
                    :key="element.email_id"
                    :label="element.name"
                    :value="element.email_id">
                  </el-option>
                </el-select>
                <el-select id="teacher-choice" v-model="searchForm.searchValue[1]" :disabled="input.isActive" style="width:49%;">  
                  <el-option
                    v-for="element in input.teacherList"
                    :key="element.email_id"
                    :label="element.name"
                    :value="element.email_id">
                  </el-option>
                </el-select>
              </div>
            </el-col>
            <el-col :span="4">
              <el-button
                style="width: 100%"
                type="primary"
                @click="searchStudent"
                class="subject-btn"
              >
                {{ $t('BANK.SEARCH') }}
              </el-button>
            </el-col>
          </el-row>
        </el-form>
        <el-table
          ref="searchStudentTable"
          :data="searchForm.studentList"
          style="width: 100%"
          @selection-change="onStudentCheckboxChange">
          <el-table-column
            type="selection">
          </el-table-column>
          <el-table-column
            prop="name"
            :label="$t('REG.NAME_LABEL')"
            width="140">
          </el-table-column>
          <el-table-column
            prop="email_id"
            :label="$t('TEACHER_CLASS.MAIL_ADDRESS')"
            >
          </el-table-column>
        </el-table>
        <el-pagination
          style="text-align: center"
          background
          layout="prev, pager, next"
          :total="searchForm.studentCount"
          :current-page.sync="searchForm.studentPage"
          :page-size="15"
          @current-change="searchStudent">
        </el-pagination>
        <el-button
            v-if="searchForm.multipleSelection.length !== 0"
            style="width: 100%"
            type="primary"
            @click="addStudent"
            class="subject-btn"
          >
            {{ $t('TEACHER_CLASS.ADD_STUD') }}
          </el-button>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import masterService from '../../services/masterService';
import authService from '../../services/authService';
import utils from '../../utils';

export default {
  name: 'RegisterClass',
  async created() {
    const vm = this;
    const accessId = utils.getUserIdFromJwt();
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push({ name: 'LandingPage' });
    }
  },
  data() {
    return {
      mainForm: {
        opened: true,
        practice: false,
        teacher_user_id: [-1],
        studentList: [],
      },
      teacherList: [
        {
          user_id: -1,
          nameAndmail: '미정',
        },
      ],
      searchCategoryList: [{
        label: '이름',
        value: 'name',
      }, {
        label: '메일 주소',
        value: 'email_id',
      }],
      universityList: [],
      departmentList: [],
      searchForm: {
        multipleSelection: [],
        searchCategory: '',
        studentPage: 1,
        studentCount: 0,
        studentList: [],
      },
    };
  },
  async mounted() {
    const vm = this;
    // 강사 목록 받아오기
    const user_list = await masterService.getUserLists_c({
      type: 1,
    });
    user_list.data.rows.forEach(element => { // eslint-disable-line arrow-parens
      element.nameAndmail = element.name.concat(': ', element.email_id); // eslint-disable-line no-param-reassign
    });
    vm.teacherList = vm.teacherList.concat(user_list.data.rows);
  },
  methods: {
    async onSubmit() {
      const vm = this;
      // 강사 배열에서 -1(미정) 제거, 중복값 제거
      const filteredTeacherArray = [];
      vm.mainForm.teacher_user_id.some(element => { // eslint-disable-line
        if (element === -1) return false;
        if (filteredTeacherArray.indexOf(element) === -1) filteredTeacherArray.push(element);
      });
      // 학생 배열에서 user_id만 추출
      const studentIdList = vm.mainForm.studentList.map(element => element.user_id);
      try {
        // 이름 중복 검사
        await masterService.ClassNameDuplicateCheck(vm.mainForm);

        // 과목 등록
        await masterService.NNMasterpostClass({
          ...vm.mainForm,
          teacher_user_id: filteredTeacherArray,
          student_user_id: studentIdList,
        });
        vm.$notify({
          title: 'Success',
          message: vm.$t('NOTIFY.SCS_CRTED_SUBJ'),
          type: 'success',
          duration: 5000,
        });
      } catch (error) {
        if (error.response.status === 409) {
          vm.$notify({
            title: 'warning',
            message: vm.$t('NOTIFY.ALRDY_SUBJ_NAME'),
            type: 'warning',
            duration: 5000,
          });
        } else {
          vm.$notify({
            title: vm.$t('NOTIFY.FAIL_CRE_SUBJ'),
            message: error.toString(),
            type: 'error',
            duration: 10000,
          });
        }
      }
    },
    addTeacherSlot() {
      const vm = this;
      vm.mainForm.teacher_user_id.push(-1);
    },
    deleteTeacherSlot(index) {
      const vm = this;
      vm.mainForm.teacher_user_id.splice(index, 1);
    },
    onSearchCategoryChange() {
      const vm = this;
      if (vm.searchForm.searchCategory === 'universityAndDepartment') {
        // TODO: 학교 목록 가져오기
      }
    },
    onUniversityChange() {
      const vm = this;
      if (vm.searchForm.searchCategory === 'universityAndDepartment') {
        // TODO: 학과 목록 가져오기
      }
    },
    onStudentCheckboxChange(val) {
      const vm = this;
      vm.searchForm.multipleSelection = val;
    },
    async searchStudent() {
      const vm = this;
      if (vm.searchForm.searchCategory === 'name' || vm.searchForm.searchCategory === 'email_id') {
        const user_listc = await masterService.getUserLists_c({
          type: 0,
          category: vm.searchForm.searchCategory,
          search_word: vm.searchForm.searchValue,
          page: vm.searchForm.studentPage,
        });
        vm.searchForm.studentList = user_listc.data.rows;
        vm.searchForm.studentCount = user_listc.data.count;
      }
    },
    removeStudent(userId) {
      const vm = this;
      for (let i = vm.mainForm.studentList.length - 1; i >= 0; i -= 1) {
        if (vm.mainForm.studentList[i].user_id === userId) {
          vm.mainForm.studentList.splice(i, 1);
          break;
        }
      }
    },
    addStudent() {
      const vm = this;
      const mainFormUserIdList = vm.mainForm.studentList.map(element => element.user_id);
      let duplicateCount = 0;
      vm.searchForm.multipleSelection.forEach(element => { // eslint-disable-line
        if (mainFormUserIdList.indexOf(element.user_id) === -1) {
          vm.mainForm.studentList.push(element);
        } else {
          duplicateCount += 1;
        }
      });

      if (duplicateCount > 0) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.NOT_NEW_ADDED'),
          type: 'warning',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style lang="scss" scoped>
#teacher_class_new_wrapper {
  .bg-gray {
    background: #d3dce6;
  }
 .page-title{
    float:left;
    width: 1000px;
    height: 24px;
    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;
    margin-top : 40px;
    margin-left : 7px;
    margin-bottom : 30px;
  }
  .all-student-list{
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;
    margin-top : 7px;
    margin-left : 7px;
    margin-bottom : 25px;
  }
  .el-form-item__label {
    font-size: 30px;
  }
  .elForm-label el-form-item{
    text-align : left;
    font-family: SpoqaHanSans;
    font-size: 16px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 40px;
    letter-spacing: normal;
    color: #000000;
  }
  .subject-title{
    width: 300px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-summary{
    width: 300px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-startDate{
    width: 140px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #d8dce6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-endDate{
    width: 140px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #d8dce6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-capacity{
      width: 300px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .teacher-description{
    width: 300px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-description{
    width: 300px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-btn{
    width: 300px;
    height: 40px;
    border-radius: 3px;
    background-color: #1989fa;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
  }
}
</style>
